# ND_InputPieces.py
# Naval Duels File - Various messages and prompts that are displayed while asking for inputs
# (c) Alan Gilfoy, 2007

ND_description = """
Welcome to the Naval Duels war-game."

This program will proceed to ask you for the amount and type of ships in two enemy warfleets. Then it will ask you to input the Admiral character commanding each fleet, these conferring bonuses and detractions on each fleet."
Then the combat function will use these inputs to calculate the result of that battle. The battle's result will then be displayed."

Would you like to use the Admiral Feature? Each admiral character provides certain bonuses and detractions by modifying the ship statistics in a certain manner."
"""

adm_feature_msg = """
This is the Admiral Feature- Who is commanding these fleets? (They are called Fleet A and Fleet B) \
Your choice of admiral affects the ship statistics used by each fleet, providing \
certain bonuses and detractions. Some choices are fictional, some are based on historical figures. \

You can have the same Admiral set for both fleets if you wish. \
        
Would you like to see the admiral descriptions? (Y for Yes, N for No.)"""

ship_input_instructions = """
When 'Number of [shiptype]' comes up, just type in the appropriate number, without commas or spaces \
(or any other sysmbols besides the number, for that matter.) \
Obviously, you cannot have a negative number of ships unless you're in the Twilight Zone. \
Thus, any negative numbers you enter will be treated as zeros."""

def display_admiral_descriptions():
    ViewAdmDesc = True
    while ViewAdmDesc:
        AdmDesc = raw_input("Y (meaning Yes) or N (meaning No)?")

        if AdmDesc.upper() == "Y":
            print
            print
            print "Admiral Code 0:"
            print "Adm. Johnathan Doe - Naval Forces of Genericland"
            print "Bonuses/Detractions:"
            print "None"
            print
            #I am going to use Nimitz along with other Admirals later; provided now as one example of what the feature looks like

            print "Admiral Code 1:"
            print "Fleet Adm. Chester Nimitz - United States Navy"
            print "Bonuses/Detractions:"
            print "All ship costs - 5%" #represents power of American industry
            print "Fighters - +10% firepower, +20% armor" #represents role of aircraft carriers in WWII Pacific
            print "Carriers - +15% armor"
            print "Submarines - +5% firepower"
            print "Frigates and Cruisers: -10% armor and firepower"
            print
            ViewAdmDesc = False
        if AdmDesc == "N" or AdmDesc == "n":
            ViewAdmDesc = False
        else:
            pass

        print
        print "Now that you've looked at the Admiral descriptions, or already had your choices in mind, which ones have you chose?"


def make_admiral_choice():
    # this loop takes into consideration the number of Admirals available,
    # and if the user has chosen an Admiral number out of that range

    TotalChoices = 1 # this will need to be manually modified when more Admirals are added
    iteration = 0
    print
    CorrectNumberCheck = True
    while CorrectNumberCheck:

        # purpose of the iteration variable and the 'tick-up' counter for it:
        # when the counter reaches a certain value, a warning is displayed.
        # when the counter reaches another value, Admirals set to defaults.
        # This is done so the user can't give out-of-range input(s) forever

        warning = "Hey you! Stop messing around! Enter Admiral numbers that are within the proper range."
        final_message = "That's it. You've had plenty of chances. Admirals set to defaults."

        Admiral_A = int(raw_input("What is the number for the Admiral of Fleet A?"))
        Admiral_B = int(raw_input("What is the number for the Admiral of Fleet B?"))
        iteration += 1

        if iteration == 5:
            print warning
                
        if iteration == 8:
            print final_message
            Admiral_A = 0
            Admiral_B = 0
            CorrectNumberCheck = False

        if Admiral_A > TotalChoices or Admiral_B > TotalChoices:
            print "There aren't that many Admirals available in Naval Duels. There is(are) only", TotalChoices, "available."
            print "So, please choose a number between 0 and", TotalChoices, "."
            Admiral_A = int(raw_input("Again, what is the number for the Admiral of Fleet A?"))
            Admiral_B = int(raw_input("Again, what is the number for the Admiral of Fleet B?"))
            iteration += 1

        if iteration == 5:
            print warning

        if iteration == 8:
            print final_message
            Admiral_A = 0
            Admiral_B = 0
            CorrectNumberCheck = False

        if Admiral_A <= TotalChoices and Admiral_B <= TotalChoices:
            print
            CorrectNumberCheck = False

    Admiral_Choices = [Admiral_A, Admiral_B]
    return Admiral_Choices
