# NavalDuels.py
# Naval Duels File - Main User Interface
# (c) Alan Gilfoy, 2007

# using 'from module_name import *' can lead to confusion-
# especially since I am importing from multiple modules that each have several functions, classes, and variables in them.
# Putting the whole name of the class, function or variable in the 'import' statement helps-
# The full names, matched with where those full names are referenced in the program, helps the code be understood.

# -<>- #

from ND_CombatEngine import *
# The ship classes (which contain the statistics), the fleets, the battle-calculation functions
# The battle-calculation functions are called CombatEngine, main_battle_calc, find_winner


from ND_InputPieces import ND_description
from ND_InputPieces import adm_feature_msg
from ND_InputPieces import ship_input_instructions
# user-interface messages that are formatted later on by the 'wrap' fucntion


from ND_InputPieces import display_admiral_descriptions
from ND_InputPieces import make_admiral_choice
# functions whose names explain their purpose.


from word_wrap import wrap # formats many of the messages displayed by the user interface

# -<>- #
# end of import statements #
# -<>- #

ND_description_wrapped = wrap(ND_description, 70)
print ND_description_wrapped

#Asks the user if he/she wants to use the admiral feature.
#If Yes (Y): asks the user if he wants to look at the descriptions, then asks for which admirals he finally picked.
#If No (N): sets each admiral to the default, then breaks the loop

use_admirals_prompt = raw_input("Y or N?")

use_admirals = True
while use_admirals:
    if use_admirals_prompt.upper() == "Y":
        #Asks for input - Admiral Feature, which modifies ship statistics
        
        adm_feature_wrapped = wrap(adm_feature_msg, 70)
        print adm_feature_wrapped

        display_admiral_descriptions()
        Admiral_Choices = make_admiral_choice()

        fleet_a.Admiral = Admiral_Choices[0]
        fleet_b.Admiral = Admiral_Choices[1]
        
        use_admirals = False # done choosing admirals

    if use_admirals_prompt.upper() == "N":
        fleet_a.Admiral = 0
        fleet_b.Admiral = 0
        use_admirals = False # user doesn't want to choose Admirals

    if use_admirals_prompt.upper() != "Y" and use_admirals_prompt.upper() != "N":
        print "Hey you! That wasn't a 'Y' or an 'N'."

# -<>- #

#Asks for input - the number of ships of each type in each fleet
print
input_instructions_wrapped = wrap(ship_input_instructions, 70)
print input_instructions_wrapped
print
print
print "Please enter the amount of each shiptype in Fleet A."
fleet_a.fi = int(raw_input("Number of Fighters-"))
fleet_a.ca = int(raw_input("Number of Carriers-"))
fleet_a.su = int(raw_input("Number of Submarines-"))
fleet_a.fr = int(raw_input("Number of Frigates-"))
fleet_a.de = int(raw_input("Number of Destroyers-"))
fleet_a.cr = int(raw_input("Number of Cruisers-"))
fleet_a.bs = int(raw_input("Number of Battleships-"))

print

print "Please enter the amount of each shiptype in Fleet B."
fleet_b.fi = int(raw_input("Number of Fighters-"))
fleet_b.ca = int(raw_input("Number of Carriers-"))
fleet_b.su = int(raw_input("Number of Submarines-"))
fleet_b.fr = int(raw_input("Number of Frigates-"))
fleet_b.de = int(raw_input("Number of Destroyers-"))
fleet_b.cr = int(raw_input("Number of Cruisers-"))
fleet_b.bs = int(raw_input("Number of Battleships-"))
#Asks for input - the number of ships of each type in each fleet

# Deal with negative inputs
if fleet_a.fi < 0:
    fleet_a.fi = 0
if fleet_a.ca < 0:
    fleet_a.ca = 0
if fleet_a.su < 0:
    fleet_a.su = 0
if fleet_a.fr < 0:
    fleet_a.fr = 0
if fleet_a.de < 0:
    fleet_a.de = 0
if fleet_a.cr < 0:
    fleet_a.cr = 0
if fleet_a.bs < 0:
    fleet_a.bs = 0

if fleet_b.fi < 0:
    fleet_b.fi = 0
if fleet_b.ca < 0:
    fleet_b.ca = 0
if fleet_b.su < 0:
    fleet_b.su = 0
if fleet_b.fr < 0:
    fleet_b.fr = 0
if fleet_b.de < 0:
    fleet_b.de = 0
if fleet_b.cr < 0:
    fleet_b.cr = 0
if fleet_b.bs < 0:
    fleet_b.bs = 0
# Deal with negative inputs

print        
print "--------------------------------------------------------"
print "Inputs acknowledged...The forces have now met in battle."
print "--------------------------------------------------------"
print

    # this block of code makes sure that printed (displayed) ship names are plural or singular, as appropriate.

display_the_fleets(fleet_a, fleet_b)

# The $64,000 Question
battle_winner = CombatEngine(fleet_a, fleet_b)
print
display_the_winner = True
while display_the_winner:
    if battle_winner == int(1):
        print "The winner of the battle is Fleet A."
        print
        display_the_winner = False
    if battle_winner == int(2):
        print "The winner of the battle is Fleet B."
        print
        display_the_winner = False
    if battle_winner == int(0):
        print "There are no true winners in war - this battle is a stalemate/draw"
        print
        display_the_winner = False
    else:
        display_the_winner = False

print "The final fleets were:"
print
display_the_fleets(fleet_a, fleet_b)
# displays the state of the fleets after the battle calculations, i.e what's left

end = raw_input("Thank you for playing Naval Duels. Press something, and hit Enter, and the program will shut down.")
